Option Strict On
Public Class frmTicTacToe
  Dim EarthTurn As Boolean ' if True, it's Earth's turn
  Dim CanClick As Boolean ' if True, can click grid
  Dim NumberClicks As Integer 'Number of grid clicks
  Dim Marker(9) As Integer 'what marker is in what location (1-Earth,2-Sun)

  Private Sub btnReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset.Click
    Dim I As Integer
    'Clear board
    picMark1.Image = Nothing
    picMark2.Image = Nothing
    picMark3.Image = Nothing
    picMark4.Image = Nothing
    picMark5.Image = Nothing
    picMark6.Image = Nothing
    picMark7.Image = Nothing
    picMark8.Image = Nothing
    picMark9.Image = Nothing
    For I = 1 To 9
      Marker(I) = 0
    Next I
    'Make it Earth's turn
    picTurn.Image = picEarth.Image
    lblTurn.Text = "Turn"
    EarthTurn = True
    CanClick = True
    NumberClicks = 0
  End Sub

  Private Sub frmTicTacToe_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    btnReset.PerformClick()
  End Sub
  Private Sub picMark_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picMark1.Click, picMark2.Click, picMark3.Click, picMark4.Click, picMark5.Click, picMark6.Click, picMark7.Click, picMark8.Click, picMark9.Click
    'Decide which picture was clicked (1-9)
    Dim picClicked As PictureBox, Index As Integer
    Dim Win As Boolean
    picClicked = CType(sender, PictureBox)
    'Index is last digit of control name
    Index = CInt(Val(Mid(picClicked.Name, Len(picClicked.Name), 1)))
    'If can't click or marker already there exit sub
    If Not (CanClick) Or Marker(Index) <> 0 Then
      Exit Sub
    End If
    'Increment click then mark
    NumberClicks = NumberClicks + 1
    If EarthTurn Then
      Marker(Index) = 1
      picClicked.Image = picEarth.Image
    Else
      Marker(Index) = 2
      picClicked.Image = picSun.Image
    End If
    Win = False
    'Check for win
    If Marker(1) = Marker(Index) And Marker(2) = Marker(Index) And Marker(3) = Marker(Index) Then
      'Top horizontal win
      Win = True
    ElseIf Marker(4) = Marker(Index) And Marker(5) = Marker(Index) And Marker(6) = Marker(Index) Then
      'Middle horizontal win
      Win = True
    ElseIf Marker(7) = Marker(Index) And Marker(8) = Marker(Index) And Marker(9) = Marker(Index) Then
      'Bottom horizontal win
      Win = True
    ElseIf Marker(1) = Marker(Index) And Marker(4) = Marker(Index) And Marker(7) = Marker(Index) Then
      'Left vertical win
      Win = True
    ElseIf Marker(2) = Marker(Index) And Marker(5) = Marker(Index) And Marker(8) = Marker(Index) Then
      'Middle vertical win
      Win = True
    ElseIf Marker(3) = Marker(Index) And Marker(6) = Marker(Index) And Marker(9) = Marker(Index) Then
      'Right vertical win
      Win = True
    ElseIf Marker(1) = Marker(Index) And Marker(5) = Marker(Index) And Marker(9) = Marker(Index) Then
      'Top, left down diagonal win
      Win = True
    ElseIf Marker(7) = Marker(Index) And Marker(5) = Marker(Index) And Marker(3) = Marker(Index) Then
      'Bottom, left up diagonal win
      Win = True
    End If
    If Win Then
      'There's a win
      lblTurn.Text = "Win!!"
      CanClick = False
    Else
      'If we got this far, this was no win
      If NumberClicks < 9 Then
        EarthTurn = Not (EarthTurn)
        If EarthTurn Then
          picTurn.Image = picEarth.Image
        Else
          picTurn.Image = picSun.Image
        End If
      Else
        'If there's nine clicks and no win, it's a tie
        picTurn.Image = Nothing
        lblTurn.Text = "A Tie ..."
        CanClick = False
      End If
    End If
  End Sub

End Class
